# B07 Fig S7 Fold and Unfold 2D Plots and Response surface Time serie plots in publ.r

#setwd("C:/copy Rworkspace/Benzene")
setwd("C:/Users/Katarina Jrgensen/Documents/Ellen_gener/Skript av alt 31.10.2018/Benzene Publ/2D plots")
getwd()

library(rsm)

rm(list=ls())

load("C:/copy Rworkspace/Benzene/workspace/qworkspace of B07 Fig S7 Fold and Unfold 2D Plots and Response surface Time serie plots in publ.RData")


load(file="./Data/GenesF.RData")
load(file="./Data/DescF.RData")
load(file="./Data/GenesU.RData")
load(file="./Data/DescU.RData")

#Extracting information from data with fold change (F)

DescF     <- as.data.frame(DescF)
#Creating a vector for exposure groups
d1        <- (-1)*(DescF$C*2-1);d1
#Vector for time points
d2        <- DescF$time
#Crteating an id for picking out data from individual time points
idf.time1 <- which(d2==1)
idf.time2 <- which(d2==2);          length(idf.time2)
#Extracting gene expression (G and Genes) and descriptor data (D, Desc) for just time 2
G.Fold.time2 <- GenesF[idf.time2,]; dim(G.Fold.time2)
D.Fold.time2 <- DescF[idf.time2,];  dim(D.Fold.time2)

#As above, for data without fold change (U)
DescU       <- as.data.frame(DescU)
d1          <- (-1)*(DescU$C*2-1);d1
d2          <- DescU$time
idu.time0   <- which(d2==0)
idu.time1   <- which(d2==1)
idu.time2   <- which(d2==2)
G.UnFold.time0 <- GenesU[idu.time0,]; dim(G.UnFold.time0)
D.UnFold.time0 <- DescU[idu.time0,];  dim(D.UnFold.time0)

#vector for alternative texting of graph points using worker IDs
names.all.workers <- c("B03","B04","B05","B06","B07","B08","B11","B12",
               "C04","C06","C07","C08","C09")

#colours to allow creating a graph colour vector based on worker groups
cls       <- c('darkolivegreen4','deeppink3')

# Get selected genes 
###################################
# Jak Stat
# manually editing of selected genes from fold change
JSTAT.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Results/gprofiler_results_JSTAT_annotated_R.xlsx"))
rownames(JSTAT.2)<- JSTAT.2[,1]
JSTAT_ILMN2 <-as.vector(JSTAT.2[,1])

# Schiffman_genes
Schiffman.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Data/Schiffman_gener_kun_en_PRG2_med_ILMN_R.Ellen.xlsx"))
rownames(Schiffman.2) <- Schiffman.2[,1]
Ill.Schif <- rownames(Schiffman.2)

# change to gennames in the columns
#######################################
Table     <- rbind(JSTAT.2,Schiffman.2)
Ill.sel   <- Table$X__1
Names.sel <- Table$names
Inn.U.time0.sel <- G.UnFold.time0[,Ill.sel]; colnames(Inn.U.time0.sel)<- Names.sel
Inn.F.time2.sel <- G.Fold.time2[,Ill.sel];   colnames(Inn.F.time2.sel)<- Names.sel

#########################
# Response surface
#########################


pdf("Fig S7. 2-D plots and response surface Genes ACSL1 CLEC5A IL6 IL19 SOCS1.  Fold and unfold data.pdf")

# Time 2 in Fold data
############################
Temp          <- data.frame(D.Fold.time2,Inn.F.time2.sel);dim(Temp)
BvsC          <- Temp$B+1;      
benz_ur       <- Temp$benz_ur
tolu_ur       <- Temp$tolu_ur
leuko         <- Temp$leuko
ACSL1         <- Temp$ACSL1
CLEC5A        <- Temp$CLEC5A
IL6           <- Temp$IL6
IL19          <- Temp$IL19 
SOCS1         <- Temp$SOCS1
IFNA16        <- Temp$IFNA16

y1 <- BvsC;y1
my.data       <- data.frame(Temp)

#Running response-surface analysis 
# Method ref: Chapter 10 of Wu, C-F J and Hamada, M (2009) "Experiments: Planning, Analysis, and Parameter Design Optimization" ISBN 978-0-471-69946-0.
rsmmod1         <- rsm(y1 ~ SO(ACSL1,CLEC5A), data = my.data)
rsmmod2         <- rsm(y1 ~ SO(IL6,IL19), data = my.data)
rsmmod3         <- rsm(y1 ~ SO(IL6,SOCS1), data = my.data)

summary(rsmmod1)
summary(rsmmod2)
summary(rsmmod3)

par(mfrow=c(2,3))
my.col <- cls[Temp$C+1]
main0.1 <- c('CLEC5A vs ACSL1')
main0.2 <- c('IL6 vs IL19')
main0.3 <- c('IL6 vs SOCS1')

main0 <- c('Fold data, time 2')
main1.0 <- c('B vs C')
main1 <- c('group and time')
main2 <- c('B_ur')
main3 <- c('B_bl')

#First, 2D plots of gene vs gene

plot(ACSL1,CLEC5A,col='gray90',main=paste0(main0,'\n',main0.1),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(ACSL1,CLEC5A,col=my.col,names1)

plot(IL6,IL19,col='gray90',main=paste0(main0,'\n',main0.2),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(IL6,IL19,col=my.col,names1)

plot(IL6,SOCS1,col='gray90',main=paste0(main0,'\n',main0.3),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(IL6,SOCS1,col=my.col,names1)

#Below, plots of the results of the rsm for each gene pair

contour(rsmmod1, ~ ACSL1+CLEC5A , at = xs(rsmmod1), image = TRUE,main=paste0('response: \n',main1.0))
contour(rsmmod2, ~ IL6+IL19 , at = xs(rsmmod2), image = TRUE,main=paste0('response: \n',main1.0))
contour(rsmmod3, ~ IL6+SOCS1 , at = xs(rsmmod3), image = TRUE,main=paste0('response: \n',main1.0))

## time 0 in unfold data
############################
Temp          <- data.frame(D.UnFold.time0,Inn.U.time0.sel);dim(Temp)
BvsC          <- Temp$B+1
benz_ur       <- Temp$benz_ur
tolu_ur       <- Temp$tolu_ur
leuko         <- Temp$leuko
ACSL1         <- Temp$ACSL1
CLEC5A        <- Temp$CLEC5A
IL6           <- Temp$IL6
IL19          <- Temp$IL19 
SOCS1         <- Temp$SOCS1
IFNA16        <- Temp$IFNA16

y1 <- BvsC

my.data       <- data.frame(Temp)
rsmmod1u         <- rsm(y1 ~ SO(ACSL1,CLEC5A), data = my.data)
rsmmod2u         <- rsm(y1 ~ SO(IL6,IL19), data = my.data)
rsmmod3u         <- rsm(y1 ~ SO(IL6,SOCS1), data = my.data)

summary(rsmmod1u)
summary(rsmmod2u)
summary(rsmmod3u)

#par(mfrow=c(2,2))
my.col <- cls[Temp$C+1]
main0.1 <- c('CLEC5A vs ACSL1')
main0.2 <- c('IL6 vs IL19')
main0.3 <- c('IL6 vs SOCS1')

main0 <- c('Unfold data, time 0')
main1.0 <- c('B vs C')
main1 <- c('group and time')
main2 <- c('B_ur')
main3 <- c('B_bl')

plot(ACSL1,CLEC5A,col='gray90',main=paste0(main0,'\n',main0.1),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(ACSL1,CLEC5A,col=my.col,names1)

plot(IL6,IL19,col='gray90',main=paste0(main0,'\n',main0.2),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(IL6,IL19,col=my.col,names1)

plot(IL6,SOCS1,col='gray90',main=paste0(main0,'\n',main0.3),cex=0.00002)
names1 <- substr(rownames(Temp),1,2)
text(IL6,SOCS1,col=my.col,names1)

contour(rsmmod1u, ~ ACSL1+CLEC5A , at = xs(rsmmod1u), image = TRUE,main=paste0('response: \n',main1.0))
contour(rsmmod2u, ~ IL6+IL19 , at = xs(rsmmod2u), image = TRUE,main=paste0('response: \n',main1.0))
contour(rsmmod3u, ~ IL6+SOCS1 , at = xs(rsmmod3u), image = TRUE,main=paste0('response: \n',main1.0))

dev.off()


save.image("C:/copy Rworkspace/Benzene/workspace/qworkspace of B07 Fig S7 Fold and Unfold 2D Plots and Response surface Time serie plots in publ.RData")

