# B 06 rev Fold Change pub Fig S5, S1, 5, 4, S2, S3, S6, S4(Ellens versjon).r

#setwd("H:/A_R/R/R data/R Haukeland/C_Haukeland/Katarina/2018")
#setwd("C:/copy Rworkspace/Benzene")
setwd("C:/Users/Katarina Jrgensen/Documents/Ellen_gener/Skript av alt 31.10.2018/Benzene publ/Fold B06 ")
getwd()


library(glmnet)
#library(readxl)

rm(list = ls())

# load Ellens data and results
#load("C:/copy Rworkspace/Benzene/workspace/workspace of B06 rev Fold Change data and results.RData")


# load our study
# F = with fold change, Genes = Genes, Desc = Worker data, chemical exposure, blood cell counts
#load(file="./Data/GenesF.RData")
#load(file="./Data/DescF.RData")

GenesF  <- as.data.frame(GenesF)
DescF   <- as.data.frame(DescF)

#Matrix containing age and time for all workers
D.extra <- cbind(DescF$age,DescF$time);rownames(D.extra)<- rownames(DescF)
GrF     <- DescF$B*2-1
my.text <- paste0(substr(rownames(DescF),1,1),DescF$age,'.',DescF$time)

#Making the exposure group vector for all individuals
d1.all  <- (-1)*(DescF$C*2-1);d1.all
#Making a time vector for all individuals
d2.all  <- DescF$time;d2.all
#Picking out the individual times
id.time1.all    <- which(d2.all==1)
id.time2.all    <- which(d2.all==2)

#Making graph colours for the exposure groups for all individuals. and all times
#cls            <- c('darkolivegreen3','deeppink3')
cls             <- c('darkolivegreen4','deeppink3')
my.cls.all.time1 <- cls[DescF$C+1][id.time1.all]
my.cls.all.time2 <- cls[DescF$C+1][id.time2.all]

# age balancing
#making ids for workers between 35 and 55 years of age
id.F       <- which(DescF$age>35 & DescF$age<55);names.F <- rownames(DescF)[id.F]
#Extracting variables for just these workers
GenesF.age <- GenesF[names.F,];dim(GenesF.age)
DescF.age  <- DescF[names.F,]
GrF.age    <- DescF.age$B*2-1
D.extra.age<- D.extra[names.F,]
my.text.age<-my.text[id.F] 

#As above, making vectors for group, time, and individual times for the balanced dataset
d1         <- (-1)*(DescF.age$C*2-1);d1
d2         <- DescF.age$time
id.time1   <- which(d2==1)
id.time2   <- which(d2==2)
B.exposure <- d1

#Making input data for the models for each time point
X.time1    <- GenesF.age[id.time1,]
X.time2    <- GenesF.age[id.time2,]
X          <- GenesF.age
y.time1    <- DescF.age[id.time1,]
y.time2    <- DescF.age[id.time2,]

#Making coulour vectors for the exposure group for a single timepoint in the balanced data.
#my.cls.a  <- cls[DescF$C+1] # all subjects
#my.cls.s  <- cls[DescF.age$C+1]
my.cls <- cls[DescF.age$C+1][id.time1]

l <- 0.05

##################################################
# functions
##################################################

#This runs Elastic Net and plots the quality of fit of the model, and returns selected genes.
run.glmnet <- function(x,y){
  glmnet.data   <- glmnet(x=x,y=y)
  cv.glmnet.data<- cv.glmnet(x=x,y=y,type.measure='mse',nfolds=length(y),alpha=0.5, grouped=FALSE)
  fit           <- cv.glmnet.data
  lambda.min    <- fit$lambda.min;
  log.lambda.min<- log(lambda.min);log.lambda.min
  c             <- coef(fit,s='lambda.min',exact=TRUE);
  c.vector      <- as.numeric(c);names(c.vector)<- rownames(c)
  temp          <- sort(c.vector);
  inds          <- which(c.vector!=0)
  n.s.glm       <- row.names(c)[inds][-1];
  plot(fit)
  plot(glmnet.data,label = TRUE)
  out <- n.s.glm
#  out <- list(glmnet.data,cv.glmnet.data,n.s.glm)
  return(out)
  }

#PCA from singular value decomposition. Returns scores and loadings for plotting.

svd_TPD <- function(data){
  TPD <-list() 
  m <- svd(data)
  d <- diag(m$d)
  D <- m$d
  U <- m$u
  V <- m$v
  
  # make PCA scores (T) og loadings (P)
  T <- U%*%d;dim(T)
  P <- V;dim(P)
  rownames(T)<- rownames(data)
  rownames(P)<- colnames(data)
  
  pc <- ('PC')
  no.pc <- length(D)
  temp <- (1:no.pc)
  colnames(T)<- paste0('PC',temp)
  colnames(P)<- paste0('PC',temp)
  
  TPD <- list(T,P,D)
  return(TPD)
}

##################################################
# get gen-names and Ill no of all genes
##################################################
#Ill.genenames.all <- as.data.frame(read_excel("./From GeneNames to Illno/GPL6883-11606-IlluminaHumanRef8v3-R.xlsx"))
Ill.G <- Ill.genenames.all[,1:6];dim(Ill.G)
df    <- as.data.frame(Ill.G)

##################################################
# get genes from Kegg and for markers from china
##################################################

# Jak Stat
#B_selected_JSTAT <- as.data.frame(read_excel("./Kegg.Katarina/JAK-STAT pathway hsa04630.xlsx"))
n_B_selected_JSTAT <- B_selected_JSTAT[,1]
vc        <- as.vector(n_B_selected_JSTAT);length(vc)
df.sel    <- df[df$ILMN_Gene %in% vc,];dim(df.sel)
JSTAT.all.genes <- df.sel;JSTAT.all.genes[1:3,]
Ill.JSTAT <- df.sel[,1]

# manually editing selected genes after Elnet
#JSTAT.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Results/gprofiler_results_JSTAT_annotated_R.xlsx"))
rownames(JSTAT.2)<- JSTAT.2[,1]
JSTAT_ILMN2 <-as.vector(JSTAT.2[,1])

# Schiffman 6 genes
#Schiffman.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Data/Schiffman_gener_kun_en_PRG2_med_ILMN_R.Ellen.xlsx"))
rownames(Schiffman.2) <- Schiffman.2[,1]
Ill.Schif.6 <- rownames(Schiffman.2)

# Schiffman 33 genes
#Schif.33 <- as.data.frame(read_excel("./Data/Schiffman.33genes.GEO.2018.10.26.xlsx"))
rownames(Schif.33)<- Schif.33[,1]
Ill.Schif.33  <- Schif.33$X__1
Name.Schif.33 <- Schif.33$Symbol
dim(Schif.33)


######################################################
# Glmnet,Y: B vs C, run separately on each timepoint
# followed by PCA
######################################################

##############
# Shif 6 genes
##############


pdf("glmnet Schiffman time 1 and time 2 separately full CV.pdf")
#tiff("Fig S1 Elnet 6 Schiffman genes time 1 and time 2 separately full CV.tiff")

par(mfrow=c(2,2))
# Chiffman time 1
my.main <- 'SChiffman, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.Schif.6]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time1 <-run.glmnet(x,y)

# Chiffman time 2
my.main <- 'SChiffman, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.Schif.6]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time2 <-run.glmnet(x,y)

dev.off()

n.s.glm.Chiffman.time1
n.s.glm.Chiffman.time2
save(n.s.glm.Chiffman.time2,file="among6.n.s.glm.Chiffman.time2.RData")


# PCA Schiffmann, 4 selected
##############################

tiff("Fig 4 All data PCA on Schif genes selected by glmnet, full CV, time 2. displayed for both times.tiff")
#pdf("Fig 4 All data PCA on Schif genes selected by glmnet, full CV, time 2. displayed for both times.pdf")


N.sel     <- Schiffman.2[n.s.glm.Chiffman.time2,1];length(N.sel)
G.names   <- as.vector(Schiffman.2[N.sel,2])
GeneNames <- G.names
#gconvert(N.sel)[,c(2,5,6)]

par(mfrow=c(2,2))

# time 1
my.cls.all.time <- my.cls.all.time1
Inn <- scale(GenesF[id.time1.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]
f <- 1.3

T <- as.data.frame(T)

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f))

plot(T[,1],T[,2], type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 1", xlim=my.xlim, ylim=my.ylim)

abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex = 0.8, col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 1", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- scale(GenesF[id.time2.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]];colnames(P)<- GeneNames 
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(c) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
#my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black",xlab = "PC1", ylab = "PC2",main="(d) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()

# PCA on all 6 Shif genes
##########################
pdf("FIG S2. All data PCA on all 6 Schif genestime 2. displayed for both times.pdf")
#tiff("FIG S2. All data PCA on all 6 Schif genestime 2. displayed for both times.tiff")

N.sel     <- Schiffman.2[,1];length(N.sel)
G.names   <- as.vector(Schiffman.2[N.sel,2])
GeneNames <- G.names
#gconvert(N.sel)[,c(2,5,6)]

par(mfrow=c(2,2))

# time 1
my.cls.all.time <- my.cls.all.time1
Inn <- scale(GenesF[id.time1.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]
f <- 1.3

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2], type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 1",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
#my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 1", 
     ,xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- scale(GenesF[id.time2.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]];colnames(P)<- GeneNames 
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2], type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(c) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
#my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(d) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()

##################################
# Elnet Shiffmann all 30 genes
##################################
#Schif.33 
Ill.Schif  <- Ill.Schif.33;length(Ill.Schif)
#Name.Schif.33 <- Schif.33$Symbol

pdf("Fig S4 Elnet 30 Schiffman genes Fold Change, glmnet ageball, PCA not age ball. time 1 and time 2 separately full CV.pdf")

# here are the age ballanced data used X.time1

par(mfrow=c(2,2))
# Chiffman time 1
my.main <- 'SChiffman, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.Schif]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time1 <-run.glmnet(x,y)

# Chiffman time 2
my.main <- 'SChiffman, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.Schif]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time2 <-run.glmnet(x,y)

dev.off()

n.s.glm.Chiffman.time1.33genes <- n.s.glm.Chiffman.time1
n.s.glm.Chiffman.time2.33genes <- n.s.glm.Chiffman.time2
length(n.s.glm.Chiffman.time2)

Shiff.sel.among.33     <- Schif.33[n.s.glm.Chiffman.time2,]
write.table(Shiff.sel.among.33,file="Shiff.sel.among.33.txt")

# selected among the 33 genes

N.sel     <- Schif.33[n.s.glm.Chiffman.time2,1];length(N.sel)
G.names   <- as.vector(Schif.33[N.sel,2])
GeneNames <- G.names

# For PCA are the all data used GenesF, not only the age ballanced data 

pdf("Fig S4 b 30 Schiffman genes Fold Change, PCA not age ball. time 1 and time 2 separately full CV.pdf")


par(mfrow=c(2,2))
f <- 1.3

# time 1
my.cls.all.time <- my.cls.all.time1
Inn     <- scale(GenesF[id.time1.all,N.sel]);dim(Inn)
names1  <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]
f <- 1.3

my.xlim <- c(min(T[,1]*f-1),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2], type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 1",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),cex=0.8, pos = 2, col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#f <- 1.6

my.xlim <- c(min(P[,1]*f-0.2),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 

plot(P[,1],P[,2],type ="p", pch= 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 1", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- scale(GenesF[id.time2.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

#f <- 1.3

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]];colnames(P)<- GeneNames 
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f-1),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(c) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#f <- 1.4

my.xlim <- c(min(P[,1]*f-0.2),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(d) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8, xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()


##################
## JSTAT
##################

## All data, each timepoints separate
# Jak STAT, selected by glm net


# Jak-STAT
pdf("Fig S5 glmnet B vs C. JSTAT time 1 and time 2 separately full CV 2018 10 18.pdf")
#tiff("./Figures/Fig S5 glmnet B vs C. JSTAT time 1 and time 2 separately full CV 2018 10 18.tiff")

par(mfrow=c(2,2))
#JSTAT time 1
my.main <- 'JSTAT, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.JSTAT]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.JSTAT.time1 <-run.glmnet(x,y)

# JSTAT time 2
my.main <- 'JSTAT, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.JSTAT]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.JSTAT.time2 <-run.glmnet(x,y)

dev.off()

n.s.glm.JSTAT.time1;length(n.s.glm.JSTAT.time1)
n.s.glm.JSTAT.time2;length(n.s.glm.JSTAT.time2)

pdf("Fig 5. All data PCA on JAK_STAT genes selected by glmnet, full CV, time 2. displayed for both times.pdf")
#tiff("./Figures/Fig 5. All data PCA on JAK_STAT genes selected by glmnet, full CV, time 2. displayed for both times.tiff")

N.sel     <- JSTAT.2[n.s.glm.JSTAT.time2,1];length(N.sel)
G.names   <- as.vector(JSTAT.2[N.sel,2])
GeneNames <- G.names

par(mfrow=c(2,2))
f <- 1.3

# time 1
my.cls.all.time <- my.cls.all.time1
Inn <- as.matrix(scale(GenesF[id.time1.all,N.sel]));dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f-0.5),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 1",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

my.xlim <- c(min(P[,1]*f-0.1),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
plot(P[,1],P[,2],type = "p", pch =20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 1", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- scale(GenesF[id.time2.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f-0.5),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(c) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

my.xlim <- c(min(P[,1]*f-0.1),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
plot(P[,1],P[,2],type = "p", pch = 20, col ="black", xlab = "PC1", ylab = "PC2",main="(d) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()


###############
## 1D plot
###############

pdf("Fig S3 1D plot unscaled on 6 Schif genes times 2 PRG2 IFNB1 ACSL1 and CLEC5A.pdf")

# time 2
my.cls.all.time <- my.cls.all.time2
N.sel     <- Schiffman.2[,1];length(N.sel)
GeneNames <- Schiffman.2[,2]
Inn       <- GenesF[id.time2.all,N.sel];dim(Inn)
names1    <- substr(rownames(Inn),1,2)

par(mfrow=c(3,2))
for (i in 1: length(N.sel)){
  my.ylim <- c(min(Inn[,i]*f),max(Inn[,i]*f))
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim)
  text(Inn[,i], as.character(names1),cex=0.8,col=my.cls.all.time)
  abline(h=0, lty=2)
  abline(v=0, lty=2)
}

dev.off()

pdf("Fig S4c 1D plot unscaled on selected Schiff30 genes times 2.pdf")
#tiff("./Figures/Fig S4c 1D plot unscaled on selected Schiff30 genes times 2.tiff")
N.sel     <- Schif.33[n.s.glm.Chiffman.time2.33genes,1];length(N.sel)
G.names   <- as.vector(Schif.33[N.sel,2])
GeneNames <- G.names

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- GenesF[id.time2.all,N.sel];dim(Inn)

names1 <- substr(rownames(Inn),1,2)

par(mfrow=c(2,2))
for (i in 1:length(N.sel)){
  my.ylim <- c(min(Inn[,i]*f),max(Inn[,i]*f))
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim)
  text(Inn[,i], as.character(names1),cex=0.8,col=my.cls.all.time)
  abline(h=0, lty=2)
  abline(v=0, lty=2)
}

dev.off()

pdf("Fig S6 1D plot unscaled on selected JakSTAT genes times 2.pdf")
#tiff("./Figures/Fig S6 1D plot unscaled on selected JakSTAT genes times 2.tiff")
N.sel     <- JSTAT.2[n.s.glm.JSTAT.time2,1];length(N.sel)
G.names   <- as.vector(JSTAT.2[N.sel,2])
GeneNames <- G.names

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- GenesF[id.time2.all,N.sel];dim(Inn)

names1 <- substr(rownames(Inn),1,2)

par(mfrow=c(2,2))
for (i in 1:length(N.sel)){
  my.ylim <- c(min(Inn[,i]*f),max(Inn[,i]*f))
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim)
  text(Inn[,i], as.character(names1),cex=0.8,col=my.cls.all.time)
  abline(h=0, lty=2)
  abline(v=0, lty=2)
}

dev.off()


##########333
## save
########3333

save.image("C:/copy Rworkspace/Benzene/workspace/workspace of B06 rev Fold Change data and results.RData")



