# B 06 rev Unfold S8 S9 (Ellens versions)

#setwd("H:/A_R/R/R data/R Haukeland/C_Haukeland/Katarina/2018")
#setwd("C:/copy Rworkspace/Benzene")
setwd("C:/Users/Katarina Jrgensen/Documents/Ellen_gener/Skript av alt 31.10.2018/Benzene Publ/Unfold B06")
getwd()

library(glmnet)
#library(readxl)

rm(list = ls())

#load("./workspace/workspace of B 06 rev Unfold S8 S9 (Ellens versions).r.RData")

# load data. U = unfold (data without fold change). 
#Genes = Genes. Desc = Descriptors (Individuals, chemical exposures, blood cell counts)
#load(file="./Data/GenesU.RData")
#load(file="./Data/DescU.RData")

GenesU  <- as.data.frame(GenesU)
DescU   <- as.data.frame(DescU)
#Matrix containing age and time for all workers
D.extra<- cbind(DescU$age,DescU$time);rownames(D.extra)<- rownames(DescU)

#Making the exposure group vector for all individuals
d1.all  <- (-1)*(DescU$C*2-1);d1.all
#Making a time vector for all individuals
d2.all  <- DescU$time;d2.all
#Picking out the individual times
id.time0.all   <- which(d2.all==0)
id.time1.all   <- which(d2.all==1)
id.time2.all   <- which(d2.all==2)

#Making graph colours for the exposure groups for all individuals. and all times
#cls       <- c('darkolivegreen3','deeppink3')
cls       <- c('darkolivegreen4','deeppink3')
my.cls.all.time0 <- cls[DescU$C+1][id.time0.all]
my.cls.all.time1 <- cls[DescU$C+1][id.time1.all]
my.cls.all.time2 <- cls[DescU$C+1][id.time2.all]

# age balancing
#making ids for workers between 35 and 55 years of age
id.U       <- which(DescU$age>35 & DescU$age<55);names.U <- rownames(DescU)[id.U]
#Extracting variables for just these workers
GenesU.age <- GenesU[names.U,];dim(GenesU.age)
DescU.age  <- DescU[names.U,]
D.extra.age<- D.extra[names.U,]

#As above, making vectors for group, time, and individual times for the balanced dataset
d1  <- (-1)*(DescU.age$C*2-1);d1
d2  <- DescU.age$time
id.time0   <- which(d2==0)
id.time1   <- which(d2==1)
id.time2   <- which(d2==2)
B.exposure <- d1;length(d1)

#Making input data for the models for each time point
X.time0    <- GenesU.age[id.time0,]
X.time1    <- GenesU.age[id.time1,]
X.time2    <- GenesU.age[id.time2,]
X          <- GenesU.age
y.time0    <- DescU.age[id.time0,]
y.time1    <- DescU.age[id.time1,]
y.time2    <- DescU.age[id.time2,]

# plot(X.time0[,'ILMN_1780465'])
# plot(X.time1[,'ILMN_1780465'])
# plot(X.time2[,'ILMN_1780465'])

#Making coulour vectors for the exposure group for a single timepoint in the balanced data.
#my.cls.a  <- cls[DescF$C+1] # all subjects
#my.cls.s  <- cls[DescF.age$C+1]
my.cls <- cls[DescU.age$C+1][id.time1]
l <- 0.05

#################################################
# Fig 2: Plot of all data vs balanced data
#################################################

pdf("Fig 2 All data vs balanced data.pdf")
#tiff("Fig 2 All data vs balanced data.tiff")


##Side by side plot###

par(mfrow=c(1,2)) 

#Panel of complete dataset#
#Extract the group and ages of all workers at a single time (need only one instance for plotting)

DescU.t2 <- DescU[id.time2.all,]

groupU.t2 <- DescU.t2$B;length(groupU.t2)
ageU.t2 <- DescU.t2$age;length(ageU.t2)

char_comp <- c("B03","B04","B05","B06","B07","B08","B11","B12",
               "C04","C06","C07","C08","C09")

plot (groupU.t2, ageU.t2, pch ="", xaxt="n", main = "Unbalanced", xlab= "", ylab ="age", xlim = c(-0.5,1.5), ylim = c(25,60))
text (groupU.t2, ageU.t2, char_comp)
axis (side=1, at = c(0,1), labels = c("unexposed","exposed"))
abline (h=35, lty = 2)
abline (h=55, lty = 2)

#balanced dataset#
#Same as above

DescU.age.t2 <-DescU.age[id.time2,]

groupU.age.t2 <- DescU.age.t2$B;length(groupU.age.t2)
ageU.age.t2 <- DescU.age.t2$age;length(ageU.age.t2)

char <- c("B03","B06","B08","B11","C04","C07","C08","C09")

plot (groupU.age.t2, ageU.age.t2, pch ="", xaxt="n", main = "Balanced", xlab ="", ylab ="", xlim = c(-0.5,1.5),ylim = c(25,60))
text (groupU.age.t2, ageU.age.t2, char)
axis (side=1, at = c(0,1), labels = c("unexposed","exposed"))
abline (h=35, lty = 2)
abline (h=55, lty = 2)

dev.off()

##################################################
# functions
##################################################

#This runs Elastic Net and plots the quality of fit of the model, and returns selected genes.
run.glmnet <- function(x,y){
  glmnet.data   <- glmnet(x=x,y=y)
  cv.glmnet.data<- cv.glmnet(x=x,y=y,type.measure='mse',nfolds=length(y),alpha=0.5, grouped=FALSE)
  fit           <- cv.glmnet.data
  lambda.min    <- fit$lambda.min;
  log.lambda.min<- log(lambda.min);log.lambda.min
  c             <- coef(fit,s='lambda.min',exact=TRUE);
  c.vector      <- as.numeric(c);names(c.vector)<- rownames(c)
  temp          <- sort(c.vector);
  inds          <- which(c.vector!=0)
  n.s.glm       <- row.names(c)[inds][-1];
  plot(fit)
  plot(glmnet.data,label = TRUE)
  out <- n.s.glm
#  out <- list(glmnet.data,cv.glmnet.data,n.s.glm)
  return(out)
  }

#PCA from singular value decomposition. Returns scores and loadings for plotting.

svd_TPD <- function(data){
  TPD <-list() 
  m <- svd(data)
  d <- diag(m$d)
  D <- m$d
  U <- m$u
  V <- m$v
  
  # make PCA scores (T) og loadings (P)
  T <- U%*%d;dim(T)
  P <- V;dim(P)
  rownames(T)<- rownames(data)
  rownames(P)<- colnames(data)
  
  pc <- ('PC')
  no.pc <- length(D)
  temp <- (1:no.pc)
  colnames(T)<- paste0('PC',temp)
  colnames(P)<- paste0('PC',temp)
  
  TPD <- list(T,P,D)
  return(TPD)
}

##################################################
# get gen-names and Ill no of all genes
##################################################
#Ill.genenames.all <- as.data.frame(read_excel("./From GeneNames to Illno/GPL6883-11606-IlluminaHumanRef8v3-R.xlsx"))
Ill.G <- Ill.genenames.all[,1:6];dim(Ill.G)
df    <- as.data.frame(Ill.G)

##################################################
# get genes from Kegg from markers from china
##################################################

# Jak Stat
#B_selected_JSTAT <- as.data.frame(read_excel("./Kegg.Katarina/JAK-STAT pathway hsa04630.xlsx"))
n_B_selected_JSTAT <- B_selected_JSTAT[,1]
vc        <- as.vector(n_B_selected_JSTAT);length(vc)
df.sel    <- df[df$ILMN_Gene %in% vc,];dim(df.sel)
rownames(df.sel)<- df.sel[,1]
idc <- which(colnames(df.sel)=='ILMN_Gene')
JSTAT.all.genes <- df.sel[,c(1,6)];JSTAT.all.genes[1:6,]
Ill.JSTAT <- rownames(JSTAT.all.genes)

# Schiffman_genes
#Schiffman.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Data/Schiffman_gener_kun_en_PRG2_med_ILMN_R.Ellen.xlsx"))
rownames(Schiffman.2) <- Schiffman.2[,1]
Ill.Schif <- rownames(Schiffman.2)

# Schiffman 33 genes
#Schif.33 <- as.data.frame(read_excel("./Data/Schiffman.33genes.GEO.2018.10.26.xlsx"))
rownames(Schif.33)<- Schif.33[,1]
Ill.Schif.33  <- Schif.33$X__1
Name.Schif.33 <- Schif.33$Symbol
dim(Schif.33)

#############
# Jak-STAT
#############


# Glmnet,Y: B vs C, run separately on each timepoint
######################################################

#tiff("./FiguresU/Fig S9 Ellens version unfold.glmnet B vs C. JSTAT time 0, 1 and time 2 separately full CV 2018 10 18.tiff")
pdf("Fig S9a. Ellens version unfold.glmnet B vs C. JSTAT time 0, 1 and time 2 separately full CV 2018 11 05.pdf")

par(mfrow=c(3,2))
#JSTAT time 0
my.main <- 'JSTAT, timepoint 0'
x <- scale(as.matrix(X.time0[,Ill.JSTAT]));dim(x)
y <- B.exposure[id.time0];y
n.s.glm.JSTAT.time0 <-run.glmnet(x,y)

#JSTAT time 1
my.main <- 'JSTAT, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.JSTAT]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.JSTAT.time1 <-run.glmnet(x,y)

# JSTAT time 2
my.main <- 'JSTAT, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.JSTAT]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.JSTAT.time2 <-run.glmnet(x,y)

dev.off()

n.s.glm.JSTAT.time0;length(n.s.glm.JSTAT.time0)
n.s.glm.JSTAT.time1;length(n.s.glm.JSTAT.time1)
n.s.glm.JSTAT.time2;length(n.s.glm.JSTAT.time2)

write.table(n.s.glm.JSTAT.time0, file ="n.s.glm.unfold.JSTAT.time0")
write.table(n.s.glm.JSTAT.time2, file ="n.s.glm.unfold.JSTAT.time2")

# PCA of selected genes - all data - only time point 0
######################################################################

f <- 1.3

## All data, each timepoints separate
# Jak STAT, selected by glm net

#tiff("./FiguresU/Fig S9 Ellens version unfold All data PCA on JAK_STAT genes selected by glmnet, full CV, time 0 and 2.tiff")
pdf("Fig S9b Ellens version unfold All data PCA on JAK_STAT genes selected by glmnet, full CV, time 0 and 2 05.11.2018.pdf")

par(mfrow=c(2,2))

N.sel     <- JSTAT.all.genes[n.s.glm.JSTAT.time0,1];length(N.sel)
id <- which(colnames(JSTAT.all.genes)=='ILMN_Gene')
G.names   <- as.vector(JSTAT.all.genes[N.sel,id])
GeneNames <- G.names

# time 0
my.cls.all.time <- my.cls.all.time0
Inn <- as.matrix(scale(GenesU[id.time0.all,N.sel]));dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2], type = "p", pch =20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 0",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 0", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)


# PCA 
########
# Skal vi her visualisere gener som selekteres ved tid 0 ?
N.sel     <- JSTAT.all.genes[n.s.glm.JSTAT.time0,1];length(N.sel)
id        <- which(colnames(JSTAT.all.genes)=='ILMN_Gene')
G.names   <- as.vector(JSTAT.all.genes[N.sel,id])
GeneNames <- G.names

# time 2
my.cls.all.time <- my.cls.all.time0
Inn     <- as.matrix(scale(GenesU[id.time2.all,N.sel]));dim(Inn)
names1  <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()

######################################################
# Schiffmann 6 selected markerd
######################################################

# Glmnet,Y: B vs C, run separately on each timepoint
######################################################

par(mfrow=c(3,2))

my.main <- 'China markers, timepoint 0'
x <- scale(as.matrix(X.time0[,Ill.Schif]));dim(x)
y <- B.exposure[id.time0];y
n.s.glm.Chiffman.time0 <-run.glmnet(x,y)

#Schiffman time 1
my.main <- 'China markers, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.Schif]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time1 <-run.glmnet(x,y)

# Schiffman time 2
my.main <- 'China markers, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.Schif]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time2 <-run.glmnet(x,y)

#dev.off()


######################################################
# Schiffmann all 30 markers 
######################################################

# Glmnet,Y: B vs C, run separately on each timepoint
######################################################

# Schiffmann

pdf("Fig S8a Ellens version All data glmnet on Schif genes, full CV, time 2. displayed for both times 05.11.2018.pdf")

par(mfrow=c(3,2))

my.main <- 'China markers, timepoint 0'
x <- scale(as.matrix(X.time0[,Ill.Schif.33]));dim(x)
y <- B.exposure[id.time0];y
n.s.glm.Chiffman.time0 <-run.glmnet(x,y)

#Schiffman time 1
my.main <- 'China markers, timepoint 1'
x <- scale(as.matrix(X.time1[,Ill.Schif.33]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time1 <-run.glmnet(x,y)

# Schiffman time 2
my.main <- 'China markers, timepoint 2'
x <- scale(as.matrix(X.time2[,Ill.Schif.33]));dim(x)
y <- B.exposure[id.time1];y
n.s.glm.Chiffman.time2 <-run.glmnet(x,y)

#dev.off()

n.s.glm.Chiffman.time0;length(n.s.glm.Chiffman.time0)
n.s.glm.Chiffman.time1;length(n.s.glm.Chiffman.time1)
n.s.glm.Chiffman.time2;length(n.s.glm.Chiffman.time2)

Schif.33[n.s.glm.Chiffman.time0,]
Schif.33[n.s.glm.Chiffman.time1,]

write.table(n.s.glm.Chiffman.time0, file ="n.s.glm.unfold.Schiff30.time0")
write.table(n.s.glm.Chiffman.time1, file ="n.s.glm.unfold.Schiff30.time1")

# Shiffmann,  selected

pdf("Fig S8b Ellens version All data PCA on Schif genes selected by glmnet, full CV, time 2. displayed for both times.pdf")
#tiff("./Figures/Fig S8 Ellens version All data PCA on Schif genes selected by glmnet, full CV, time 0. displayed for all times.tiff")

par(mfrow=c(2,2))
# time 0

N.sel     <- Schif.33[n.s.glm.Chiffman.time0,1];length(N.sel)
G.names   <- as.vector(Schif.33[N.sel,2])
GeneNames <- G.names

my.cls.all.time <- my.cls.all.time0
Inn <- scale(GenesU[id.time0.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]
f <- 1.3

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2], type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 0",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos =2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
#my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2], type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 0", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- scale(GenesU[id.time2.all,N.sel]);dim(Inn)
names1 <- rownames(Inn)

TPD <- svd_TPD(Inn)
T <- TPD[[1]]
P <- TPD[[2]]
S <- TPD[[3]]
f <- 1.3

my.xlim <- c(min(T[,1]*f),max(T[,1]*f)) 
my.ylim <- c(min(T[,2]*f),max(T[,2]*f)) 
plot(T[,1],T[,2],type = "p", pch = 20, col = my.cls.all.time, xlab = "PC1", ylab = "PC2",main="(a) Score plot \n time point 2",
     xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)
text(T[,1],T[,2],as.character(names1),pos = 2, cex=0.8,col=my.cls.all.time,xlim=my.xlim,ylim=my.ylim)

#my.xlim <- c(min(P[,1]*f),max(P[,1]*f)) 
#my.ylim <- c(min(P[,2]*f),max(P[,2]*f)) 
my.xlim <- c(-1,1) 
my.ylim <- c(-1,1) 
plot(P[,1],P[,2],type = "p", pch = 20, col = "black", xlab = "PC1", ylab = "PC2",main="(b) Loading plot \n time point 2", 
     xlim=my.xlim,ylim=my.ylim)
text(P[,1],P[,2], GeneNames, pos = 2, cex=0.8,xlim=my.xlim,ylim=my.ylim)
abline(h=0, lty=2)
abline(v=0, lty=2)

dev.off()

###############
## 1D plot
###############

pdf("Unfold 1D plot Jak STAT unscaled on selectedtime 0.pdf")
N.sel     <- JSTAT.all.genes[n.s.glm.JSTAT.time0,1];length(N.sel)
id <- which(colnames(JSTAT.all.genes)=='ILMN_Gene')
G.names   <- as.vector(JSTAT.all.genes[N.sel,id])
GeneNames <- G.names

# time 0
my.cls.all.time <- my.cls.all.time0
Inn <- GenesU[id.time0.all,N.sel];dim(Inn)
#names1 <- substr(rownames(Inn),1,2)
names1 <- rownames(Inn)

par(mfrow=c(2,2))

for (i in 1:dim(Inn)[2]){
  my.ylim <- c((min(Inn[,i])),max((Inn[,i])))
  my.xlim <- c(-0.5, dim(Inn)[1]+0.5)
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim, xlim=my.xlim)
  text(Inn[,i], char_comp,cex=0.8,col=my.cls.all.time,ylim=my.ylim)
}

dev.off()

pdf("Unfold 1D plot Jak STAT unscaled on selectedtime 2.pdf")
N.sel     <- JSTAT.all.genes[n.s.glm.JSTAT.time2,1];length(N.sel)
id <- which(colnames(JSTAT.all.genes)=='ILMN_Gene')
G.names   <- as.vector(JSTAT.all.genes[N.sel,id])
GeneNames <- G.names

# time 2
my.cls.all.time <- my.cls.all.time2
Inn <- GenesU[id.time2.all,N.sel];dim(Inn)
#names1 <- substr(rownames(Inn),1,2)
names1 <- rownames(Inn)

par(mfrow=c(2,2))

for (i in 1:dim(Inn)[2]){
  my.ylim <- c((min(Inn[,i])),max((Inn[,i])))
  my.xlim <- c(-0.5, dim(Inn)[1]+0.5)
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim, xlim=my.xlim)
  text(Inn[,i], char_comp,cex=0.8,col=my.cls.all.time,ylim=my.ylim)
}

dev.off()


pdf("Unfold 1D plot unscaled on selected Schif genes time 0 .pdf")

N.sel     <- Schif.33[n.s.glm.Chiffman.time0,1];length(N.sel)
G.names   <- as.vector(Schif.33[N.sel,2])
GeneNames <- G.names

# time 0

my.cls.all.time <- my.cls.all.time0
Inn <- GenesU[id.time0.all,N.sel];dim(Inn)
#names1 <- substr(rownames(Inn),1,2)

par(mfrow=c(2,2))
for (i in 1:dim(Inn)[2]){
  my.ylim <- c(min(Inn[,i]),max(Inn[,i]))
 # my.xlim <- c(-0.5, dim(Inn)[1]+0.5)
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim)
  text(Inn[,i], char_comp,cex=0.8,col=my.cls.all.time,ylim=my.ylim)
 
}

dev.off()

pdf("Unfold 1D plot unscaled on selected Schif genes time 1.pdf")

N.sel     <- Schif.33[n.s.glm.Chiffman.time1,1];length(N.sel)
G.names   <- as.vector(Schif.33[N.sel,2])
GeneNames <- G.names

# time 0

my.cls.all.time <- my.cls.all.time1
Inn <- GenesU[id.time1.all,N.sel];dim(Inn)
#names1 <- substr(rownames(Inn),1,2)

par(mfrow=c(2,2))
for (i in 1:dim(Inn)[2]){
  my.ylim <- c(min(Inn[,i]),max(Inn[,i]))
  # my.xlim <- c(-0.5, dim(Inn)[1]+0.5)
  plot(Inn[,i],col=my.cls.all.time,cex=0.0001,xlab='samples',ylab='exprs.level',
       main=GeneNames[i],ylim=my.ylim)
  text(Inn[,i], char_comp,cex=0.8,col=my.cls.all.time,ylim=my.ylim)
  
}

dev.off()



save.image("./workspace/workspace of B 06 rev Unfold S8 S9 (Ellens versions).r.RData")

