# B10 Means Fig 6 in publ.r

setwd("C:/copy Rworkspace/Benzene")

library(MUDE)
library(readxl)
rm(list=ls())

load("C:/copy Rworkspace/Benzene/workspace/Workspace of B10 Means Fig 6 in publ.RData")


cls       <- c('darkolivegreen4','deeppink3')

##################################################
# Load data
##################################################
load("./Data/GenesF.RData")
load("./Data/DescF.RData")
load("./Data/GenesU.RData")
load("./Data/DescU.RData")

# The script is run without scale in the submitted paper, can also as here be run as scaled
GenesF <- scale(GenesF)
GenesU <- scale(GenesU)

##################################################
# Functions
##################################################

# to split the data in one table of B exposed and one table of Controls
make.BandC <- function(Data, N.sel){
  Temp <- Data
  BvsC    <- Temp$B
  idB     <- which(BvsC==1);idC <- which(BvsC==0)
  common <- intersect(N.sel,colnames(Temp))
  Selected   <- Temp[,common]
  Data.B     <- Selected[idB,]
  Data.C     <- Selected[idC,]
  Out <- list(Data.B,Data.C)
  return(Out)
}

##################################################
# get gen-names and Ill no of all genes
##################################################
Ill.genenames.all <- as.data.frame(read_excel("./From GeneNames to Illno/GPL6883-11606-IlluminaHumanRef8v3-R.xlsx"))
Ill.G <- Ill.genenames.all[,1:6];dim(Ill.G)
df    <- as.data.frame(Ill.G)

##################################################

# get gen-names and Ill no of all genes
##################################################

# Jak Stat,all
#B_selected_JSTAT <- as.data.frame(read_excel("./Kegg.Katarina/JAK-STAT pathway hsa04630.xlsx"))
#n_B_selected_JSTAT <- B_selected_JSTAT[,1]
#vc        <- as.vector(n_B_selected_JSTAT);length(vc)
#df.sel    <- df[df$ILMN_Gene %in% vc,];dim(df.sel)
#JSTAT.all.genes <- df.sel;JSTAT.all.genes[1:3,]


# manually editing of selected genes
JSTAT.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Results/gprofiler_results_JSTAT_annotated_R.xlsx"))
rownames(JSTAT.2)<- JSTAT.2[,1]
Ill.JSTAT  <- JSTAT.2$X__1
Name.JSTAT <- JSTAT.2$names
dim(JSTAT.2)

# Schiffman_genes
Schiffman.2 <- as.data.frame(read_excel("C:/copy Rworkspace/Benzene/Data/Schiffman_gener_kun_en_PRG2_med_ILMN_R.Ellen.xlsx"))
rownames(Schiffman.2) <- Schiffman.2[,1]
Ill.Schif  <- Schiffman.2$X__1
Name.Schif <- Schiffman.2$names
dim(Schiffman.2)

################################
## All genes in JSTAT and Shif
################################
DescU <- data.frame(DescU)
DescF <- data.frame(DescF)


N.sel.Illno <- c(Ill.JSTAT,Ill.Schif);length(N.sel.Illno)
N.sel.names <- c(Name.JSTAT,Name.Schif);length(N.sel.names)

# in publ Fig 6 and S10
N.sel.Illno <- c(Ill.Schif);length(N.sel.Illno)
N.sel.names <- c(Name.Schif);length(N.sel.names)

GenesF.sel <- GenesF[,N.sel.Illno];colnames(GenesF.sel)<- N.sel.names
GenesU.sel <- GenesU[,N.sel.Illno];colnames(GenesU.sel)<- N.sel.names
N.sel <- colnames(GenesF.sel)

DescU <- as.data.frame(DescU)
DescF <- as.data.frame(DescF)

idU.time0   <- which(DescU$time==0)
idU.time1   <- which(DescU$time==1)
idU.time2   <- which(DescU$time==2)

idF.time1   <- which(DescF$time==1)
idF.time2   <- which(DescF$time==2)

F.1   <- data.frame(DescF,GenesF.sel)[idF.time1,]
F.2   <- data.frame(DescF,GenesF.sel)[idF.time2,]

U.0   <- data.frame(DescU,GenesU.sel)[idU.time0,]
U.1   <- data.frame(DescU,GenesU.sel)[idU.time1,]
U.2   <- data.frame(DescU,GenesU.sel)[idU.time2,]

# Split the data in one table for B and one for C
F.1.G.B <- make.BandC(Data=F.1, N.sel)[[1]]
F.1.G.C <- make.BandC(Data=F.1, N.sel)[[2]]
F.2.G.B <- make.BandC(Data=F.2, N.sel)[[1]]
F.2.G.C <- make.BandC(Data=F.2, N.sel)[[2]]

U.0.G.B <- make.BandC(Data=U.0, N.sel)[[1]]
U.0.G.C <- make.BandC(Data=U.0, N.sel)[[2]]
U.1.G.B <- make.BandC(Data=U.1, N.sel)[[1]]
U.1.G.C <- make.BandC(Data=U.1, N.sel)[[2]]
U.2.G.B <- make.BandC(Data=U.2, N.sel)[[1]]
U.2.G.C <- make.BandC(Data=U.2, N.sel)[[2]]

################################################################
# Make Means and Conf Intervals for B and C separately
################################################################

# UnFold genes
X1 <- U.0.G.C;
X2 <- U.0.G.B
mean.U.0.G.C<- apply(X1,2,mean);
mean.U.0.G.B<- apply(X2,2,mean)
CI.U.0.G <- confints(X1, X2, confidence = 0.95, df.used = 0)

X1 <- U.2.G.C;
X2 <- U.2.G.B
mean.U.2.G.C<- apply(X1,2,mean);
mean.U.2.G.B<- apply(X2,2,mean)
CI.U.2.G <- confints(X1, X2, confidence = 0.95, df.used = 0)

# Fold genes
X1 <- F.1.G.C;
X2 <- F.1.G.B
mean.F.1.G.C<- apply(X1,2,mean);
mean.F.1.G.B<- apply(X2,2,mean)
CI.F.1.G <- confints(X1, X2, confidence = 0.95, df.used = 0)

X1 <- F.2.G.C;
X2 <- F.2.G.B
mean.F.2.G.C<- apply(X1,2,mean);
mean.F.2.G.B<- apply(X2,2,mean)
CI.F.2.G <- confints(X1, X2, confidence = 0.95, df.used = 0)

# Time.series Unfold 0 and 2
T.U.C.means <-  rbind(mean.U.0.G.C,mean.U.2.G.C)
T.U.B.means <-  rbind(mean.U.0.G.B,mean.U.2.G.B)

A <- rbind(T.U.C.means,T.U.B.means);dim(A)


pdf("./Figures/Fig 6 Scaled Unfold all selected genes, Means. Genes time0 and time2.pdf")
par(mfrow=c(3,3))
for(i in 1:dim(T.U.B.means)[2]){
  my.ylim <- c(min(A[,i]),max(A[,i]))
  
  plot(T.U.B.means[,i],ylab='exprs.level',xlab='time point',cex=0.0001,
       main=N.sel[i],ylim=my.ylim,xaxt='n')
  axis(1,at=c(1,2),label=c('time 0','time 2'))
  
  lines(T.U.B.means[,i],ylim=my.ylim,col=cls[1])
  lines(T.U.C.means[,i],ylim=my.ylim,col=cls[2])
}

dev.off()

save.image("C:/copy Rworkspace/Benzene/workspace/Workspace of B10 Means Fig 6 in publ.RData")


